Subject: Cannot export content elements anymore

Description

When | try to export some content in the Typo3 Backend | get the following error message:

#1: PHP Catchable Fatal Error: Argument 2 passed to TYPO3\CMS\Backend\Utility\lconUtility::getSpritelconForRecord() must
be of the type array, null given, called in
/var/www/t3versions/typo3_src-6.2.1/typo3/sysext/impexp/Classes/Controller/ImportExportController.php on line 583 and
defined in /var/www/t3versions/typo3_src-6.2.1/typo3/sysext/backend/Classes/Utility/IconUtility.php line 723 (More information)

TYPO3\CMS\Core\Error\ErrorHandler::handleError(4096, "Argument 2 passed to
TYPO3\CMS\Backend\Utility\Ico...ImportExportController.php on line 583 and defined",
"/var/www/t3versions/typo3_src-6.2.1/typo3/sysext/backend/Classes/Utility/IconUtility.php”, 723, array)

TYPO3\CMS\Backend\Utility\lconUtility::getSpritelconForRecord("tt_content%3A2", NULL)

| did some logging inside ImportExportController.php and found some sort of missing URL decoding or double encoding

problem:

Here is what $inData and the GET-Param tx_impexp in the ImportExportController.php looks like:

Array ( [action] => export [record] => Array ( [0] => tt_content%3A2 ) [external_ref] => Array ( [tables] => Array ( [0] => _ALL))
)

My URL in the Browser-Frame:

http://.../typo3/mod.php?M=xMOD_tximpexp&moduleToken=a10ff0b5cf0dd89e7ddcd8dbebb725e90a48a986&tx_impexp%5Ba
ction%5D=export&tx_impexp%5Brecord%5D%5B0%5D=tt_content%253A2&tx_impexp%5Bexternal_ref%5D%5Btables%5D%5B0)
5B0%5D=_ALL&id=2

For some reason its "tt_content%3A2" and not "tt_content:2"
Thats why all subsequent attempts in the code to explode the string by ":" fail and the error is thrown.
As far as | can tell the Error exists since | updated my Typo3 website from 6.1 to 6.2.

Any idea why this URL-encoding bug might happen ?

Related issues:
related to Core - Task # 55671: impexp entry script cleanup

Resolved

2014-02-04

Associated revisions

Revision bc1f2642 - 2014-05-06 23:19 - Wouter Wolters

[BUGFIX] Fix exporting content elements

Exporting a content element leads to a fatal error.
A wrong url encoding is the cause of the problem.

Resolves: #58576

Releases: 6.2

Change-Id: Ib2105aa9dc95e35eba9515cfc3d62b174919870a
Reviewed-on: https://review.typo3.0rg/29903

Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn
Reviewed-by: Marc Bastian Heinrichs
Tested-by: Marc Bastian Heinrichs

History

#1 - 2014-05-06 20:59 - Wouter Wolters
- Status changed from New to Accepted
- Assigned To set to Wouter Wolters

#2 - 2014-05-06 21:51 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/29903

#3 - 2014-05-06 21:52 - Wouter Wolters

- Status changed from Under Review to Accepted

Can you test the test in the reviewing system and vote if it works for you, thanks in advanced!

#4 - 2014-05-06 21:52 - Wouter Wolters

- Status changed from Accepted to Under Review
#5 - 2014-05-06 23:30 - Wouter Wolters

- Status changed from Under Review to Resolved
- % Done changed from 0 to 100
https://review.typo3.org/29903
https://review.typo3.org/29903

Applied in changeset commit:bc1f264201cf5bb82b1adc4c478e161dbb6afd104.
